Index: trunk/src/VBox/Devices/Network/slirp/slirp_state.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/slirp_state.h	(revision 20301)
+++ trunk/src/VBox/Devices/Network/slirp/slirp_state.h	(revision 20302)
@@ -347,8 +347,8 @@
 #define queue_tcp_label tcb
 #define queue_udp_label udb
-#define __X(x) x
-#define _X(x) __X(x)
-#define _str(x) #x
-#define str(x) _str(x)
+#define VBOX_X2(x) x
+#define VBOX_X(x) VBOX_X2(x)
+#define VBOX_STR2(x) #x
+#define VBOX_STR(x) VBOX_STR2(x)
 
 #ifdef VBOX_WITH_SLIRP_MT
@@ -358,5 +358,5 @@
         int rc;                                                       \
         /* Assert(strcmp(RTThreadSelfName(), "EMT") != 0); */         \
-        rc = RTCritSectEnter(&_X(queue) ## _mutex);                   \
+        rc = RTCritSectEnter(&VBOX_X(queue) ## _mutex);               \
         AssertReleaseRC(rc);                                          \
     } while (0)
@@ -364,5 +364,5 @@
     do {                                                              \
         int rc;                                                       \
-        rc = RTCritSectLeave(&_X(queue) ## _mutex);                   \
+        rc = RTCritSectLeave(&VBOX_X(queue) ## _mutex);               \
         AssertReleaseRC(rc);                                          \
     } while (0)
@@ -380,11 +380,11 @@
 
 # define QSOCKET_FOREACH(so, sonext, label)                           \
-    QSOCKET_LOCK(__X(queue_## label ## _label));                      \
-    (so) = (_X(queue_ ## label ## _label)).so_next;                   \
-    QSOCKET_UNLOCK(__X(queue_## label ##_label));                     \
-    if ((so) != &(_X(queue_## label ## _label))) SOCKET_LOCK((so));   \
+    QSOCKET_LOCK(VBOX_X2(queue_## label ## _label));                  \
+    (so) = (VBOX_X(queue_ ## label ## _label)).so_next;               \
+    QSOCKET_UNLOCK(VBOX_X2(queue_## label ##_label));                 \
+    if ((so) != &(VBOX_X(queue_## label ## _label))) SOCKET_LOCK((so));\
     for (;;)                                                          \
     {                                                                 \
-        if ((so) == &(_X(queue_## label ## _label)))                  \
+        if ((so) == &(VBOX_X(queue_## label ## _label)))              \
         {                                                             \
             break;                                                    \
@@ -399,14 +399,14 @@
     (sonext) = (so)->so_next;                                           \
     SOCKET_UNLOCK(so);                                                  \
-    QSOCKET_LOCK(_X(queue_ ## label ## _label));                        \
-    if ((sonext) != &(_X(queue_## label ## _label)))                    \
+    QSOCKET_LOCK(VBOX_X(queue_ ## label ## _label));                    \
+    if ((sonext) != &(VBOX_X(queue_## label ## _label)))                \
     {                                                                   \
         SOCKET_LOCK((sonext));                                          \
-        QSOCKET_UNLOCK(_X(queue_ ## label ## _label));                  \
+        QSOCKET_UNLOCK(VBOX_X(queue_ ## label ## _label));              \
     }                                                                   \
     else                                                                \
     {                                                                   \
-        so = &_X(queue_ ## label ## _label);                            \
-        QSOCKET_UNLOCK(_X(queue_ ## label ## _label));                  \
+        so = &VBOX_X(queue_ ## label ## _label);                        \
+        QSOCKET_UNLOCK(VBOX_X(queue_ ## label ## _label));              \
         break;                                                          \
     }                                                                   \
@@ -590,5 +590,5 @@
                 && so->so_fport        == (dport))                      \
                 {                                                       \
-                    if (sonxt != &__X(queue_ ## label ## _label))       \
+                    if (sonxt != &VBOX_X2(queue_ ## label ## _label))       \
                         SOCKET_UNLOCK(sonxt);                           \
                     break; /*so is locked*/                             \
@@ -606,6 +606,6 @@
 # define QSOCKET_LOCK_DESTROY(queue) do {} while (0)
 # define QSOCKET_FOREACH(so, sonext, label)                              \
-    for ((so)  = __X(queue_ ## label ## _label).so_next;                 \
-         (so) != &(__X(queue_ ## label ## _label));                      \
+    for ((so)  = VBOX_X2(queue_ ## label ## _label).so_next;                 \
+         (so) != &(VBOX_X2(queue_ ## label ## _label));                      \
          (so) = (sonext))                                                \
     {                                                                    \
@@ -628,5 +628,5 @@
 # define SOLOOKUP(so, label, src, sport, dst, dport)                                      \
     do {                                                                                  \
-        (so) = solookup(&__X(queue_ ## label ## _label), (src), (sport), (dst), (dport)); \
+        (so) = solookup(&VBOX_X2(queue_ ## label ## _label), (src), (sport), (dst), (dport)); \
     } while (0)
 # define DO_UDP_DETACH(data, so, ignored) udp_detach((data), (so))