Index: trunk/include/VBox/VBoxDev.h
===================================================================
--- trunk/include/VBox/VBoxDev.h	(revision 20267)
+++ trunk/include/VBox/VBoxDev.h	(revision 20363)
@@ -33,5 +33,5 @@
 #include <VBox/cdefs.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** Mouse capability bits
@@ -85,5 +85,5 @@
 #define VMMDEV_HEAP_SIZE (4*PAGE_SIZE)
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/VBoxGuest.h
===================================================================
--- trunk/include/VBox/VBoxGuest.h	(revision 20267)
+++ trunk/include/VBox/VBoxGuest.h	(revision 20363)
@@ -1666,5 +1666,5 @@
 /* General-purpose functions */
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 VBGLR3DECL(int)     VbglR3Init(void);
 VBGLR3DECL(int)     VbglR3InitUser(void);
@@ -1747,5 +1747,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 #endif /* IN_RING3 */
Index: trunk/include/VBox/VBoxGuestLib.h
===================================================================
--- trunk/include/VBox/VBoxGuestLib.h	(revision 20267)
+++ trunk/include/VBox/VBoxGuestLib.h	(revision 20363)
@@ -69,5 +69,5 @@
 typedef uint32_t VBGLIOPORT;
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 #ifdef VBGL_VBOXGUEST
@@ -326,5 +326,5 @@
 DECLVBGL(int) VbglQueryVMMDevMemory (VMMDevMemory **ppVMMDevMemory);
 
-__END_DECLS
+RT_END_DECLS
 
 /** @} */
Index: trunk/include/VBox/VBoxHDD.h
===================================================================
--- trunk/include/VBox/VBoxHDD.h	(revision 20267)
+++ trunk/include/VBox/VBoxHDD.h	(revision 20363)
@@ -41,5 +41,5 @@
 #include <VBox/vmapi.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 #ifdef IN_RING0
@@ -1735,5 +1735,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 /** @} */
Index: trunk/include/VBox/cfgm.h
===================================================================
--- trunk/include/VBox/cfgm.h	(revision 20267)
+++ trunk/include/VBox/cfgm.h	(revision 20363)
@@ -62,5 +62,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 #ifdef IN_RING3
@@ -187,5 +187,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 /** @} */
Index: trunk/include/VBox/cpum.h
===================================================================
--- trunk/include/VBox/cpum.h	(revision 20267)
+++ trunk/include/VBox/cpum.h	(revision 20363)
@@ -36,5 +36,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_cpum      The CPU Monitor / Manager API
@@ -1043,5 +1043,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/include/VBox/cpumdis.h
===================================================================
--- trunk/include/VBox/cpumdis.h	(revision 20267)
+++ trunk/include/VBox/cpumdis.h	(revision 20363)
@@ -38,5 +38,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 /** @addtogroup grp_cpum
  * @{
@@ -57,5 +57,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/include/VBox/csam.h
===================================================================
--- trunk/include/VBox/csam.h	(revision 20267)
+++ trunk/include/VBox/csam.h	(revision 20363)
@@ -54,5 +54,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 
@@ -307,5 +307,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/dbg.h
===================================================================
--- trunk/include/VBox/dbg.h	(revision 20267)
+++ trunk/include/VBox/dbg.h	(revision 20363)
@@ -41,5 +41,5 @@
 #include <iprt/stdarg.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @def VBOX_WITH_DEBUGGER
@@ -731,5 +731,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/dbgf.h
===================================================================
--- trunk/include/VBox/dbgf.h	(revision 20267)
+++ trunk/include/VBox/dbgf.h	(revision 20363)
@@ -40,5 +40,5 @@
 #include <iprt/dbg.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 
@@ -1041,5 +1041,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/dbggui.h
===================================================================
--- trunk/include/VBox/dbggui.h	(revision 20267)
+++ trunk/include/VBox/dbggui.h	(revision 20363)
@@ -39,5 +39,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_dbggui    VirtualBox Debugger GUI
@@ -172,5 +172,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/dis.h
===================================================================
--- trunk/include/VBox/dis.h	(revision 20267)
+++ trunk/include/VBox/dis.h	(revision 20363)
@@ -39,5 +39,5 @@
 #endif
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 
@@ -759,5 +759,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/em.h
===================================================================
--- trunk/include/VBox/em.h	(revision 20267)
+++ trunk/include/VBox/em.h	(revision 20363)
@@ -36,5 +36,5 @@
 #include <VBox/dis.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_em        The Execution Monitor / Manager API
@@ -229,5 +229,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/gmm.h
===================================================================
--- trunk/include/VBox/gmm.h	(revision 20267)
+++ trunk/include/VBox/gmm.h	(revision 20363)
@@ -35,5 +35,5 @@
 #include <VBox/sup.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup   grp_gmm     GMM - The Global Memory Manager
@@ -427,6 +427,6 @@
 /** @} */
 
-__END_DECLS
-
-#endif
-
+RT_END_DECLS
+
+#endif
+
Index: trunk/include/VBox/gvmm.h
===================================================================
--- trunk/include/VBox/gvmm.h	(revision 20267)
+++ trunk/include/VBox/gvmm.h	(revision 20363)
@@ -36,5 +36,5 @@
 #include <VBox/sup.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_GVMM  GVMM - The Global VM Manager.
@@ -238,5 +238,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/hwaccm.h
===================================================================
--- trunk/include/VBox/hwaccm.h	(revision 20267)
+++ trunk/include/VBox/hwaccm.h	(revision 20363)
@@ -57,5 +57,5 @@
 } HWACCMSTATE;
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /**
@@ -164,5 +164,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/include/VBox/intnet.h
===================================================================
--- trunk/include/VBox/intnet.h	(revision 20267)
+++ trunk/include/VBox/intnet.h	(revision 20363)
@@ -37,5 +37,5 @@
 #include <iprt/asm.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 
@@ -980,5 +980,5 @@
 #endif /* IN_RING0 */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/iom.h
===================================================================
--- trunk/include/VBox/iom.h	(revision 20267)
+++ trunk/include/VBox/iom.h	(revision 20363)
@@ -35,5 +35,5 @@
 #include <VBox/dis.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 
@@ -277,5 +277,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/mm.h
===================================================================
--- trunk/include/VBox/mm.h	(revision 20267)
+++ trunk/include/VBox/mm.h	(revision 20363)
@@ -38,5 +38,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_mm       The Memory Manager API
@@ -351,7 +351,7 @@
 
 /** @} */
-__END_DECLS
-
-
-#endif
-
+RT_END_DECLS
+
+
+#endif
+
Index: trunk/include/VBox/ostypes.h
===================================================================
--- trunk/include/VBox/ostypes.h	(revision 20267)
+++ trunk/include/VBox/ostypes.h	(revision 20363)
@@ -33,5 +33,5 @@
 #include <iprt/cdefs.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /**
@@ -115,5 +115,5 @@
 } VBOXOSTYPE;
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/patm.h
===================================================================
--- trunk/include/VBox/patm.h	(revision 20267)
+++ trunk/include/VBox/patm.h	(revision 20363)
@@ -36,5 +36,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_patm      The Patch Manager API
@@ -671,5 +671,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/include/VBox/pdmapi.h
===================================================================
--- trunk/include/VBox/pdmapi.h	(revision 20267)
+++ trunk/include/VBox/pdmapi.h	(revision 20363)
@@ -37,5 +37,5 @@
 #include <VBox/types.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm       The Pluggable Device Manager API
@@ -129,5 +129,5 @@
 #endif
 
-__END_DECLS
+RT_END_DECLS
 
 /** @} */
Index: trunk/include/VBox/pdmasynccompletion.h
===================================================================
--- trunk/include/VBox/pdmasynccompletion.h	(revision 20267)
+++ trunk/include/VBox/pdmasynccompletion.h	(revision 20363)
@@ -36,5 +36,5 @@
 #include <iprt/assert.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_async_completion  The PDM Async I/O Completion API
@@ -320,5 +320,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmasynctask.h
===================================================================
--- trunk/include/VBox/pdmasynctask.h	(revision 20267)
+++ trunk/include/VBox/pdmasynctask.h	(revision 20363)
@@ -33,5 +33,5 @@
 #include <VBox/types.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 
@@ -60,5 +60,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmcritsect.h
===================================================================
--- trunk/include/VBox/pdmcritsect.h	(revision 20267)
+++ trunk/include/VBox/pdmcritsect.h	(revision 20363)
@@ -34,5 +34,5 @@
 #include <iprt/critsect.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_critsect      The PDM Critical Section API
@@ -74,5 +74,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmdev.h
===================================================================
--- trunk/include/VBox/pdmdev.h	(revision 20267)
+++ trunk/include/VBox/pdmdev.h	(revision 20363)
@@ -45,5 +45,5 @@
 #include <iprt/stdarg.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_device    The PDM Devices API
@@ -3910,5 +3910,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmdrv.h
===================================================================
--- trunk/include/VBox/pdmdrv.h	(revision 20267)
+++ trunk/include/VBox/pdmdrv.h	(revision 20363)
@@ -48,5 +48,5 @@
 #endif
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_driver    The PDM Drivers API
@@ -963,5 +963,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmifs.h
===================================================================
--- trunk/include/VBox/pdmifs.h	(revision 20267)
+++ trunk/include/VBox/pdmifs.h	(revision 20363)
@@ -34,5 +34,5 @@
 #include <VBox/hgcmsvc.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_interfaces    The PDM Interface Definitions
@@ -2462,5 +2462,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmqueue.h
===================================================================
--- trunk/include/VBox/pdmqueue.h	(revision 20267)
+++ trunk/include/VBox/pdmqueue.h	(revision 20363)
@@ -33,5 +33,5 @@
 #include <VBox/types.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_queue     The PDM Queues API
@@ -134,5 +134,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmsrv.h
===================================================================
--- trunk/include/VBox/pdmsrv.h	(revision 20267)
+++ trunk/include/VBox/pdmsrv.h	(revision 20363)
@@ -35,5 +35,5 @@
 #include <VBox/cfgm.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_services  The PDM Services API
@@ -333,5 +333,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmthread.h
===================================================================
--- trunk/include/VBox/pdmthread.h	(revision 20267)
+++ trunk/include/VBox/pdmthread.h	(revision 20363)
@@ -37,5 +37,5 @@
 #endif
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_thread    The PDM Threads API
@@ -298,5 +298,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pdmusb.h
===================================================================
--- trunk/include/VBox/pdmusb.h	(revision 20267)
+++ trunk/include/VBox/pdmusb.h	(revision 20363)
@@ -44,5 +44,5 @@
 #include <iprt/stdarg.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pdm_usbdev    The USB Devices API
@@ -773,5 +773,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/pgm.h
===================================================================
--- trunk/include/VBox/pgm.h	(revision 20267)
+++ trunk/include/VBox/pgm.h	(revision 20363)
@@ -38,5 +38,5 @@
 #include <VBox/hwacc_vmx.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_pgm   The Page Monitor / Manager API
@@ -569,5 +569,5 @@
 #endif /* IN_RING3 */
 
-__END_DECLS
+RT_END_DECLS
 
 /** @} */
Index: trunk/include/VBox/rem.h
===================================================================
--- trunk/include/VBox/rem.h	(revision 20267)
+++ trunk/include/VBox/rem.h	(revision 20363)
@@ -37,5 +37,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_rem      The Recompiled Execution Manager API
@@ -103,5 +103,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/include/VBox/selm.h
===================================================================
--- trunk/include/VBox/selm.h	(revision 20267)
+++ trunk/include/VBox/selm.h	(revision 20363)
@@ -38,5 +38,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_selm      The Selector Monitor(/Manager) API
@@ -120,5 +120,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/ssm.h
===================================================================
--- trunk/include/VBox/ssm.h	(revision 20267)
+++ trunk/include/VBox/ssm.h	(revision 20363)
@@ -36,5 +36,5 @@
 #include <VBox/vmapi.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_ssm       The Saved State Manager API
@@ -521,5 +521,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/stam.h
===================================================================
--- trunk/include/VBox/stam.h	(revision 20267)
+++ trunk/include/VBox/stam.h	(revision 20363)
@@ -40,5 +40,5 @@
 #endif
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_stam     The Statistics Manager API
@@ -1125,6 +1125,6 @@
 /** @} */
 
-__END_DECLS
-
-#endif
-
+RT_END_DECLS
+
+#endif
+
Index: trunk/include/VBox/sup.h
===================================================================
--- trunk/include/VBox/sup.h	(revision 20267)
+++ trunk/include/VBox/sup.h	(revision 20363)
@@ -37,5 +37,5 @@
 #include <iprt/asm.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup   grp_sup     The Support Library API
@@ -1146,5 +1146,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/tm.h
===================================================================
--- trunk/include/VBox/tm.h	(revision 20267)
+++ trunk/include/VBox/tm.h	(revision 20363)
@@ -37,5 +37,5 @@
 #endif
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_tm        The Time Manager API
@@ -250,5 +250,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/trpm.h
===================================================================
--- trunk/include/VBox/trpm.h	(revision 20267)
+++ trunk/include/VBox/trpm.h	(revision 20363)
@@ -36,5 +36,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 /** @defgroup grp_trpm The Trap Monitor API
  * @{
@@ -149,5 +149,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/usb.h
===================================================================
--- trunk/include/VBox/usb.h	(revision 20267)
+++ trunk/include/VBox/usb.h	(revision 20363)
@@ -33,5 +33,5 @@
 #include <VBox/types.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /**
@@ -256,6 +256,6 @@
 #endif /* VBOX_USB_H_INCL_DESCRIPTORS */
 
-__END_DECLS
-
-#endif
-
+RT_END_DECLS
+
+#endif
+
Index: trunk/include/VBox/usblib-win.h
===================================================================
--- trunk/include/VBox/usblib-win.h	(revision 20267)
+++ trunk/include/VBox/usblib-win.h	(revision 20363)
@@ -229,5 +229,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 #ifdef IN_RING3
@@ -278,7 +278,7 @@
 /** @} */
 
-__END_DECLS
-
-
-#endif
-
+RT_END_DECLS
+
+
+#endif
+
Index: trunk/include/VBox/usblib.h
===================================================================
--- trunk/include/VBox/usblib.h	(revision 20267)
+++ trunk/include/VBox/usblib.h	(revision 20363)
@@ -48,5 +48,5 @@
 /** @todo merge the usblib-win.h interface into the darwin and linux ports where suitable. */
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 /** @defgroup grp_USBLib    USBLib - USB Support Library
  * This module implements the basic low-level OS interfaces and common USB code.
@@ -119,5 +119,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/vm.h
===================================================================
--- trunk/include/VBox/vm.h	(revision 20267)
+++ trunk/include/VBox/vm.h	(revision 20363)
@@ -963,5 +963,5 @@
 
 #ifdef IN_RC
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** The VM structure.
@@ -971,5 +971,5 @@
 extern DECLIMPORT(VM)   g_VM;
 
-__END_DECLS
+RT_END_DECLS
 #endif
 
Index: trunk/include/VBox/vmapi.h
===================================================================
--- trunk/include/VBox/vmapi.h	(revision 20267)
+++ trunk/include/VBox/vmapi.h	(revision 20363)
@@ -38,5 +38,5 @@
 #include <iprt/stdarg.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_vmm_apis  VM All Contexts API
@@ -447,9 +447,9 @@
 #endif
 
-__END_DECLS
-
-/** @} */
-
-#endif
-
-
+RT_END_DECLS
+
+/** @} */
+
+#endif
+
+
Index: trunk/include/VBox/vmm.h
===================================================================
--- trunk/include/VBox/vmm.h	(revision 20267)
+++ trunk/include/VBox/vmm.h	(revision 20363)
@@ -38,5 +38,5 @@
 #include <iprt/stdarg.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_vmm       The Virtual Machine Monitor API
@@ -117,5 +117,5 @@
  *
  * @returns VBox status code.
- * @param   pVM     Pointer to the shared VM structure. 
+ * @param   pVM     Pointer to the shared VM structure.
  * @param   pvUser  User specified argument
  */
@@ -140,5 +140,5 @@
  *
  * @returns true / false.
- * @param   pVM     Pointer to the shared VM structure. 
+ * @param   pVM     Pointer to the shared VM structure.
  */
 #define VMMIsHwVirtExtForced(pVM)   ((pVM)->fHwVirtExtForced)
@@ -349,5 +349,5 @@
 
 /** @} */
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/include/VBox/vrdpapi.h
===================================================================
--- trunk/include/VBox/vrdpapi.h	(revision 20267)
+++ trunk/include/VBox/vrdpapi.h	(revision 20363)
@@ -52,5 +52,5 @@
 #define VRDP_DEFAULT_PORT (3389)
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /* Forward declaration of the VRDP server instance handle. */
@@ -1187,5 +1187,5 @@
 typedef FNVRDPCREATESERVER *PFNVRDPCREATESERVER;
 
-__END_DECLS
+RT_END_DECLS
 
 /** @} */
Index: trunk/include/VBox/vusb.h
===================================================================
--- trunk/include/VBox/vusb.h	(revision 20267)
+++ trunk/include/VBox/vusb.h	(revision 20363)
@@ -34,5 +34,5 @@
 #include <VBox/types.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @defgroup grp_vusb  VBox USB API
@@ -1003,5 +1003,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif