Index: trunk/src/VBox/Runtime/r0drv/alloc-r0drv.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/alloc-r0drv.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/alloc-r0drv.h	(revision 20364)
@@ -36,5 +36,5 @@
 #include "internal/magics.h"
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /**
@@ -68,5 +68,5 @@
 void        rtMemFree(PRTMEMHDR pHdr);
 
-__END_DECLS
+RT_END_DECLS
 #endif
 
Index: trunk/src/VBox/Runtime/r0drv/darwin/the-darwin-kernel.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/darwin/the-darwin-kernel.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/darwin/the-darwin-kernel.h	(revision 20364)
@@ -87,5 +87,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 /* mach/vm_types.h */
 typedef struct pmap *pmap_t;
@@ -120,5 +120,5 @@
 extern int ml_get_max_cpus(void);
 
-__END_DECLS
+RT_END_DECLS
 
 
@@ -127,9 +127,9 @@
  */
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 extern lck_grp_t *g_pDarwinLockGroup;
 int  rtThreadPreemptDarwinInit(void);
 void rtThreadPreemptDarwinTerm(void);
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/src/VBox/Runtime/r0drv/linux/string.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/linux/string.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/linux/string.h	(revision 20364)
@@ -34,5 +34,5 @@
 #include <iprt/cdefs.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 #ifndef bool /* Linux 2.6.19 C++ nightmare */
 #define bool bool_type
@@ -56,5 +56,5 @@
     ;
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/src/VBox/Runtime/r0drv/mp-r0drv.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/mp-r0drv.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/mp-r0drv.h	(revision 20364)
@@ -34,5 +34,5 @@
 #include <iprt/mp.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /**
@@ -71,5 +71,5 @@
 void rtMpNotificationDoCallbacks(RTMPEVENT enmEvent, RTCPUID idCpu);
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/src/VBox/Runtime/r0drv/nt/internal-r0drv-nt.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/internal-r0drv-nt.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/nt/internal-r0drv-nt.h	(revision 20364)
@@ -34,5 +34,5 @@
 #include <iprt/cpuset.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /*******************************************************************************
@@ -54,5 +54,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/src/VBox/Runtime/r0drv/nt/the-nt-kernel.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/the-nt-kernel.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/nt/the-nt-kernel.h	(revision 20364)
@@ -41,7 +41,7 @@
 # define _InterlockedAddLargeStatistic  _InterlockedAddLargeStatistic_StupidDDKVsCompilerCrap
 # pragma warning(disable : 4163)
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 # include <ntddk.h>
-__END_DECLS
+RT_END_DECLS
 # pragma warning(default : 4163)
 # undef  _InterlockedExchange
@@ -50,7 +50,7 @@
 # undef  _InterlockedAddLargeStatistic
 #else
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 # include <ntddk.h>
-__END_DECLS
+RT_END_DECLS
 #endif
 
Index: trunk/src/VBox/Runtime/r0drv/nt/thread-r0drv-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/thread-r0drv-nt.cpp	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/nt/thread-r0drv-nt.cpp	(revision 20364)
@@ -41,7 +41,7 @@
 #include "internal-r0drv-nt.h"
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 NTSTATUS NTAPI ZwYieldExecution(void);
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/src/VBox/Runtime/r0drv/os2/the-os2-kernel.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/the-os2-kernel.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/os2/the-os2-kernel.h	(revision 20364)
@@ -40,5 +40,5 @@
 #include <os2ddk/devhlp.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 extern PCDOSTABLE   g_pDosTable;
@@ -51,5 +51,5 @@
 DECLASM(int) RTR0Os2DHVMGlobalToProcess(ULONG fFlags, PVOID pvR0, ULONG cb, PPVOID ppvR3);
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp	(revision 20364)
@@ -101,9 +101,9 @@
 *   Internal Functions                                                         *
 *******************************************************************************/
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 DECLASM(void) rtTimerOs2Tick(void);
 DECLASM(int) rtTimerOs2Arm(void);
 DECLASM(int) rtTimerOs2Dearm(void);
-__END_DECLS
+RT_END_DECLS
 
 
Index: trunk/src/VBox/Runtime/r0drv/power-r0drv.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/power-r0drv.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/power-r0drv.h	(revision 20364)
@@ -34,5 +34,5 @@
 #include <iprt/power.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /* Called from initterm-r0drv.cpp: */
@@ -40,5 +40,5 @@
 void rtR0PowerNotificationTerm(void);
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: trunk/src/VBox/Runtime/r0drv/solaris/the-solaris-kernel.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/solaris/the-solaris-kernel.h	(revision 20355)
+++ trunk/src/VBox/Runtime/r0drv/solaris/the-solaris-kernel.h	(revision 20364)
@@ -61,7 +61,7 @@
 #include <iprt/cdefs.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 extern struct ddi_dma_attr g_SolarisX86PhysMemLimits;
-__END_DECLS
+RT_END_DECLS
 
 #endif