Index: /trunk/src/VBox/HostDrivers/Support/SUPDrvIDC.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPDrvIDC.h	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/SUPDrvIDC.h	(revision 20366)
@@ -226,5 +226,5 @@
  * Most OSes uses
  */
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 #if defined(RT_OS_DARWIN)
@@ -250,5 +250,5 @@
 #endif
 
-__END_DECLS
+RT_END_DECLS
 
 /**
Index: /trunk/src/VBox/HostDrivers/Support/SUPDrvInternal.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPDrvInternal.h	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/SUPDrvInternal.h	(revision 20366)
@@ -49,5 +49,5 @@
 
 #if defined(RT_OS_WINDOWS)
-    __BEGIN_DECLS
+    RT_BEGIN_DECLS
 #   if (_MSC_VER >= 1400) && !defined(VBOX_WITH_PATCHED_DDK)
 #       define _InterlockedExchange           _InterlockedExchange_StupidDDKVsCompilerCrap
@@ -76,5 +76,5 @@
 #   define memcmp(a,b,c) mymemcmp(a,b,c)
     int VBOXCALL mymemcmp(const void *, const void *, size_t);
-    __END_DECLS
+    RT_END_DECLS
 
 #elif defined(RT_OS_LINUX)
@@ -191,7 +191,7 @@
 #endif
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 int  linux_dprintf(const char *format, ...);
-__END_DECLS
+RT_END_DECLS
 
 /* debug printf */
@@ -624,5 +624,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /*******************************************************************************
@@ -651,6 +651,6 @@
 bool VBOXCALL   supdrvDetermineAsyncTsc(uint64_t *pu64DiffCores);
 
-__END_DECLS
-
-#endif
-
+RT_END_DECLS
+
+#endif
+
Index: /trunk/src/VBox/HostDrivers/Support/SUPLibInternal.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPLibInternal.h	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/SUPLibInternal.h	(revision 20366)
@@ -242,5 +242,5 @@
 *   OS Specific Function                                                       *
 *******************************************************************************/
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 int     suplibOsInstall(void);
 int     suplibOsUninstall(void);
@@ -315,7 +315,7 @@
 
 
-__END_DECLS
-
-
-#endif
-
+RT_END_DECLS
+
+
+#endif
+
Index: /trunk/src/VBox/HostDrivers/Support/SUPR0IdcClientInternal.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPR0IdcClientInternal.h	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/SUPR0IdcClientInternal.h	(revision 20366)
@@ -43,7 +43,7 @@
 #  define _InterlockedAddLargeStatistic  _InterlockedAddLargeStatistic_StupidDDKVsCompilerCrap
 #  pragma warning(disable : 4163)
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 #  include <ntddk.h>
-__END_DECLS
+RT_END_DECLS
 #  pragma warning(default : 4163)
 #  undef  _InterlockedExchange
@@ -52,7 +52,7 @@
 #  undef  _InterlockedAddLargeStatistic
 # else
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 #  include <ntddk.h>
-__END_DECLS
+RT_END_DECLS
 # endif
 #endif /* RT_OS_WINDOWS */
@@ -80,10 +80,10 @@
 AssertCompile(RT_SIZEOFMEMB(SUPDRVIDCHANDLE, apvPadding) >= sizeof(struct SUPDRVIDCHANDLEPRIVATE));
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 PSUPDRVIDCHANDLE supR0IdcGetHandleFromSession(PSUPDRVSESSION pSession);
 int VBOXCALL supR0IdcNativeOpen(PSUPDRVIDCHANDLE pHandle, PSUPDRVIDCREQCONNECT pReq);
 int VBOXCALL supR0IdcNativeClose(PSUPDRVIDCHANDLE pHandle, PSUPDRVIDCREQHDR pReq);
 int VBOXCALL supR0IdcNativeCall(PSUPDRVIDCHANDLE pHandle, uint32_t iReq, PSUPDRVIDCREQHDR pReq);
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: /trunk/src/VBox/HostDrivers/Support/SUPSvcInternal.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPSvcInternal.h	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/SUPSvcInternal.h	(revision 20366)
@@ -37,5 +37,5 @@
 #include <iprt/getopt.h>
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** @name Common Helpers
@@ -90,5 +90,5 @@
 /** @} */
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: /trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 20366)
@@ -71,7 +71,7 @@
 
 #ifdef VBOX_WITH_HOST_VMX
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 # include <i386/vmx.h>
-__END_DECLS
+RT_END_DECLS
 #endif
 
@@ -89,5 +89,5 @@
 *   Internal Functions                                                         *
 *******************************************************************************/
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 static kern_return_t    VBoxDrvDarwinStart(struct kmod_info *pKModInfo, void *pvData);
 static kern_return_t    VBoxDrvDarwinStop(struct kmod_info *pKModInfo, void *pvData);
@@ -101,5 +101,5 @@
 
 static IOReturn         VBoxDrvDarwinSleepHandler(void *pvTarget, void *pvRefCon, UInt32 uMessageType, IOService *pProvider, void *pvMessageArgument, vm_size_t argSize);
-__END_DECLS
+RT_END_DECLS
 
 
@@ -162,5 +162,5 @@
  * Declare the module stuff.
  */
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 extern kern_return_t _start(struct kmod_info *pKModInfo, void *pvData);
 extern kern_return_t _stop(struct kmod_info *pKModInfo, void *pvData);
@@ -170,5 +170,5 @@
 DECLHIDDEN(kmod_stop_func_t *)  _antimain = VBoxDrvDarwinStop;
 DECLHIDDEN(int)                 _kext_apple_cc = __APPLE_CC__;
-__END_DECLS
+RT_END_DECLS
 
 
Index: /trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.cpp	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/os2/SUPDrv-os2.cpp	(revision 20366)
@@ -64,5 +64,5 @@
 #define SESSION_HASH(sfn) ((sfn) % RT_ELEMENTS(g_apSessionHashTab))
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 /* Defined in SUPDrvA-os2.asm */
 extern uint16_t             g_offLogHead;
@@ -74,5 +74,5 @@
 extern uint16_t             g_cchInitText;
 extern uint16_t             g_cchInitTextMax;
-__END_DECLS
+RT_END_DECLS
 
 
Index: /trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 20366)
@@ -91,7 +91,7 @@
 *   Exported Functions                                                         *
 *******************************************************************************/
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 ULONG _stdcall DriverEntry(PDRIVER_OBJECT pDrvObj, PUNICODE_STRING pRegPath);
-__END_DECLS
+RT_END_DECLS
 
 
Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/VBoxNetAdpInternal.h
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/VBoxNetAdpInternal.h	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/VBoxNetAdpInternal.h	(revision 20366)
@@ -29,5 +29,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** Pointer to the globals. */
@@ -221,5 +221,5 @@
 DECLHIDDEN(void) vboxNetAdpDeleteGlobalsBase(PVBOXNETADPGLOBALS pGlobals);
 DECLHIDDEN(int) vboxNetAdpTryDeleteIdc(PVBOXNETADPGLOBALS pGlobals);
-                 
+
 
 
@@ -338,5 +338,5 @@
 
 
-__END_DECLS
+RT_END_DECLS
 
 #endif
Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/darwin/VBoxNetAdp-darwin.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/darwin/VBoxNetAdp-darwin.cpp	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/darwin/VBoxNetAdp-darwin.cpp	(revision 20366)
@@ -45,7 +45,7 @@
 
 #include <sys/systm.h>
-__BEGIN_DECLS /* Buggy 10.4 headers, fixed in 10.5. */
+RT_BEGIN_DECLS /* Buggy 10.4 headers, fixed in 10.5. */
 #include <sys/kpi_mbuf.h>
-__END_DECLS
+RT_END_DECLS
 
 #include <net/ethernet.h>
@@ -96,8 +96,8 @@
 *   Internal Functions                                                         *
 *******************************************************************************/
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 static kern_return_t    VBoxNetAdpDarwinStart(struct kmod_info *pKModInfo, void *pvData);
 static kern_return_t    VBoxNetAdpDarwinStop(struct kmod_info *pKModInfo, void *pvData);
-__END_DECLS
+RT_END_DECLS
 
 static int VBoxNetAdpDarwinOpen(dev_t Dev, int fFlags, int fDevType, struct proc *pProcess);
@@ -111,5 +111,5 @@
  * Declare the module stuff.
  */
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 extern kern_return_t _start(struct kmod_info *pKModInfo, void *pvData);
 extern kern_return_t _stop(struct kmod_info *pKModInfo, void *pvData);
@@ -119,5 +119,5 @@
 DECLHIDDEN(kmod_stop_func_t  *) _antimain = VBoxNetAdpDarwinStop;
 DECLHIDDEN(int)                 _kext_apple_cc = __APPLE_CC__;
-__END_DECLS
+RT_END_DECLS
 
 /**
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/VBoxNetFltInternal.h
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/VBoxNetFltInternal.h	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/VBoxNetFltInternal.h	(revision 20366)
@@ -29,5 +29,5 @@
 
 
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 
 /** Pointer to the globals. */
@@ -419,6 +419,6 @@
 
 
-__END_DECLS
-
-#endif
-
+RT_END_DECLS
+
+#endif
+
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/darwin/VBoxNetFlt-darwin.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/darwin/VBoxNetFlt-darwin.cpp	(revision 20365)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/darwin/VBoxNetFlt-darwin.cpp	(revision 20366)
@@ -58,8 +58,8 @@
 #include <sys/kern_event.h>
 #include <net/kpi_interface.h>
-__BEGIN_DECLS /* Buggy 10.4 headers, fixed in 10.5. */
+RT_BEGIN_DECLS /* Buggy 10.4 headers, fixed in 10.5. */
 #include <sys/kpi_mbuf.h>
 #include <net/kpi_interfacefilter.h>
-__END_DECLS
+RT_END_DECLS
 #include <net/if.h>
 
@@ -84,8 +84,8 @@
 *   Internal Functions                                                         *
 *******************************************************************************/
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 static kern_return_t    VBoxNetFltDarwinStart(struct kmod_info *pKModInfo, void *pvData);
 static kern_return_t    VBoxNetFltDarwinStop(struct kmod_info *pKModInfo, void *pvData);
-__END_DECLS
+RT_END_DECLS
 
 
@@ -118,5 +118,5 @@
  * Declare the module stuff.
  */
-__BEGIN_DECLS
+RT_BEGIN_DECLS
 extern kern_return_t _start(struct kmod_info *pKModInfo, void *pvData);
 extern kern_return_t _stop(struct kmod_info *pKModInfo, void *pvData);
@@ -126,5 +126,5 @@
 DECLHIDDEN(kmod_stop_func_t  *) _antimain = VBoxNetFltDarwinStop;
 DECLHIDDEN(int)                 _kext_apple_cc = __APPLE_CC__;
-__END_DECLS
+RT_END_DECLS
 
 